
/*
les AUTEURS : TEKENG ARMEL HUGO ( code permanent: TEKA64360000 )
 *            TAMBA  WAKOU GRACE ANDREA ( code permanent: TAMG84340500 )
 *            TCHOFFO SONKOUAT BORIS DACSIN ( code permanent: TCHB09349900 )
*/

#include <iostream>
#include <fstream>
#include <vector>
#include <chrono>

typedef unsigned char UCHAR;
struct IMAGERAW {
    int hauteur;
    int largeur;
    std::vector<UCHAR> image;
};

/*
* titre: lire_image
* description : elle permet de lire une image a partir du fichier .raw
*/
IMAGERAW lire_image(const std::string& benji) {
    std::ifstream fichier(benji, std::ios::binary);
    if (!fichier) {
        std::cerr << "Erreur lors de l'ouverture du fichier " << benji << '\n';
        exit(0);
    }

    IMAGERAW image;
    image.hauteur = 1690;
    image.largeur = 1409;
    image.image.resize(image.hauteur * image.largeur);

    fichier.read(reinterpret_cast<char*>(image.image.data()), image.image.size());
    return image;
}

/*
titre :crypter_decrypter
description : elle permet de crypter ou décrypter une image stockee dans une image
*/
IMAGERAW crypter_decrypter(const IMAGERAW& imageS, UCHAR cle, bool par_colonne) {
    IMAGERAW imageD = imageS;

    if (par_colonne) {
        for (int j = 0; j < imageS.largeur; ++j) {
            for (int i = 0; i < imageS.hauteur; ++i) {
                imageD.image[i * imageS.largeur + j] ^= cle;
            }
        }
    }
    else {
        for (int i = 0; i < imageS.hauteur; ++i) {
            for (int j = 0; j < imageS.largeur; ++j) {
                imageD.image[i * imageS.largeur + j] ^= cle;
            }
        }
    }

    return imageD;
}

/*
titre : ecrire_image
description : elle permet d’ecrire une image cryptee ou decryptee dans le fichier .raw
*/
void ecrire_image(const IMAGERAW& imageD, const std::string& benji) {
    std::ofstream fichier(benji, std::ios::binary);
    if (!fichier) {
        std::cerr << "Erreur lors de l'ouverture du fichier " << benji << '\n';
        exit(1);
    }

    fichier.write(reinterpret_cast<const char*>(imageD.image.data()), imageD.image.size());
}

int main() {
    UCHAR cle = 0xAA;
    bool par_colonne;
    std::cout << "Voulez-vous effectuer le calcul par colonne (1) ou par rangee (2) ? ";
    std::cin >> par_colonne;

    auto debut = std::chrono::high_resolution_clock::now();
    IMAGERAW imageS = lire_image("benji.raw");
    IMAGERAW imageD = crypter_decrypter(imageS, cle, par_colonne);
    ecrire_image(imageD, "benji_crypte.raw");
    auto fin = std::chrono::high_resolution_clock::now();

    auto temps_execution = std::chrono::duration_cast<std::chrono::seconds>(fin - debut).count();
    std::cout << "Temps d'execution : " << temps_execution << " secondes\n";

    return 0;
}