//Adja Mame Penda Ndiaye
//NDIA82360300
//GROUPE 01
#include <stdio.h>
#include <stdlib.h>

typedef unsigned char UCHAR;

struct IMAGERAW {
    int hauteur;
    int largeur;
    UCHAR *image;
};

typedef struct IMAGERAW IMAGE;

IMAGE *lire_image() {
    char nomfichier[80];
    IMAGE *im;
    FILE *fpI;

    // Demander nom de fichier, ouvrir le fichier en lecture et valider
    printf("Entrez le nom du fichier : ");
    scanf("%s", nomfichier);

    fpI = fopen(nomfichier, "rb");

    // Vérifier si l'ouverture du fichier a réussi
    if (fpI == NULL) {
        perror("Erreur lors de l'ouverture du fichier");
        exit(EXIT_FAILURE);
    }

    // Allouer de l'espace mémoire pour im
    im = (IMAGE *)malloc(sizeof(IMAGE));

    // Lire la hauteur et la largeur de l'image
    fread(&im->hauteur, sizeof(int), 1, fpI);
    fread(&im->largeur, sizeof(int), 1, fpI);

    // Allouer de l'espace mémoire pour im->image
    im->image = (UCHAR *)malloc(im->hauteur * im->largeur * sizeof(UCHAR));

    // Lire l'image depuis le disque
    fread(im->image, sizeof(UCHAR), im->hauteur * im->largeur, fpI);

    // Fermer le fichier
    fclose(fpI);

    // Retourner le pointeur sur IMAGE
    return im;
}

void ecrire_image(IMAGE *imageD) {
    char nomfichier[80];
    FILE *fpD;

    // Demander le nom du fichier à écrire
    printf("Entrez le nom du fichier de sortie : ");
    scanf("%s", nomfichier);

    // Ouvrir le fichier en écriture
    fpD = fopen(nomfichier, "wb");

    // Vérifier si l'ouverture du fichier a réussi
    if (fpD == NULL) {
        perror("Erreur lors de l'ouverture du fichier de sortie");
        exit(EXIT_FAILURE);
    }

    // Écrire l'image dans le fichier
    fwrite(imageD->image, sizeof(UCHAR), imageD->hauteur * imageD->largeur, fpD);

    // Fermer le fichier
    fclose(fpD);
}

IMAGE *crypter_decrypter(IMAGE *imageS) {
    // DECLARATIONS DES VARIABLES

    int L = imageS->largeur;
    int H = imageS->hauteur;
    UCHAR cle = 15;

    for (int m = 0; m < H; m++) {
        for (int n = 0; n < L; n++) {
            // Cryptage/décryptage par rangée
            imageS->image[m * L + n] = imageS->image[m * L + n] ^ cle;
        }
    }

    return imageS;
}

//Fonction principale
int main() {
    IMAGE *im;

    // LECTURE DE L'IMAGE A CRYPTER
    im = lire_image();

    // DECLARATION DE VARIABLES
    UCHAR cle = 0x53;
    char choix;

    // CRYPTAGE DE L'IMAGE ET DECRYPTAGE
    im = crypter_decrypter(im);

    // Demander à l'utilisateur s'il veut crypter/décrypter par rangée ou par colonne
    printf("Crypter/Décrypter par rangée (A) ou par colonne (B) ? ");
    scanf(" %c", &choix);

    // Appliquer le cryptage/décryptage en fonction du choix de l'utilisateur
    if (choix == 'A') {
        im = crypter_decrypter_rang(im);
    } else if (choix == 'B') {
        im = crypter_decrypter_col(im);
    } else {
        printf("Choix invalide.\n");
    }

    // SAUVEGARDE DE L'IMAGE CRYPTEE
    ecrire_image(im, "image_cryptee.raw");

    // LIBERER LA RAM ATTRIBUEE DYNAMIQUEMENT
    free(im->image);
    free(im);

    return 0;
}

