/********************************************************************
// TP3 Auteurs: Yannick Lemire 		LEMY14307400 groupe 01 mais je vais le mardi soir
//              Gabriel Levasseur   LEVG92080300 groupe 00
//              Derek Stevens       STED71290300 groupe 00
//
// Objectifs: Programme qui permet de crypter ou dcrypter une image emmagasine dans un fichier .raw,
// mais dans le fond on compare le temps que les diffrentes mthodes prennent pour parcourir
// un tableau par range, par colonne ou sans positionnement
//
// Date : 2023-12-10
//********************************************************************/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/timeb.h>
#include <time.h>
//Dfinition d'une constante UCHAR pour reprsenter 8 bit unsigned
typedef unsigned char UCHAR;
//Dfinition d'une structure IMAGERAW , 4 bytes = hauteur de l'image ensuite 4 bytes  = largeur de l'image 8 bytes = adresse du pointeur de l'image
struct IMAGERAW {
	int hauteur;
	int largeur;
	UCHAR * image;};
//Dfinition d'une constante IMAGE pour reprsenter la structure IMAGERAW
typedef struct IMAGERAW IMAGE;
// Dfinitions des fonctions du programme
IMAGE *lireImage();
IMAGE *crypter_decrypter(IMAGE *);
void ecrire_image(IMAGE *);

// Fonction : Principale qui permet de crypter ou dcrypter une image emmagasine dans un fichier .raw
// Input : aucun
// Output: Retourne 0
int main(){
    IMAGE *ipointeurImage; // Dclaration d'un pointeur d'IMAGE donc d'une structure

    ipointeurImage = lireImage(); // Appel de la fonction lireImage en recevant le pointeur retourn par la fonction
    if(ipointeurImage != NULL ){// Si LireImage() retourne rien on sort
        crypter_decrypter(ipointeurImage); // Appel de la fonction crypter_decrypter avec le pointeur de l'image
        ecrire_image(ipointeurImage);// Appel de la fonction ecrire_image avec le pointeur de l'image
    }
    else{
        printf("\n Probleme avec l'entree du fichier, fermeture");// Problme avec la lecture du fichier
    }
    free(ipointeurImage->image); // Libration de l'espace mmoire rserv pour stocker l'image
    free(ipointeurImage); // Libration du pointeur
    return(0);
 }
//Fonction: crit une image sur le disque
//Entree: Le pointeur de l'image  crire sur le disque
//Sortie: Rien
IMAGE *lireImage(){

    char nomfichier[254]; // variable pour chemin du fichier
    IMAGE *ipointeurImageLire = (IMAGE *) malloc(sizeof(IMAGE)); // Gnration du pointeur d'image et rservation de son espace
    FILE *fpPointeurFichier; // Gnration du pointeur de fichier
    int hauteur,largeur,grosseur; // Variables pour gestion
    int nombreByteLus;
    int probleme = 1; // var pour dtecter problmes

    printf("\nVeuillez entrer le nom du fichier a modifier max 250 car: ");
    scanf("%s",nomfichier);//Lecture de l'entre clavier, nom du fichier
    fpPointeurFichier = fopen(nomfichier,"r");//Ouverture du fichier en lecture
    printf("\nVeuillez entrer la hauteur/nombre de lignes de l'image a modifier: ");
    scanf("%i",&hauteur);//Lecture de l'entre clavier, hauteur de l'image
    printf("\nVeuillez entrer la largeur/nombre de colonnes de l'image a modifier: ");
    scanf("%i",&largeur);//Lecture de l'entre clavier, largeur de l'image
    if(largeur > 0 && hauteur > 0){ // Verification de validit des proprits
        if(fpPointeurFichier != NULL){// Verification de validit du pointeur de fichier si ouverture ok
            grosseur= hauteur*largeur ;// tabli le nombre de bytes qui devrait tre crit
            ipointeurImageLire->largeur = largeur;//Fixe la valeur de la proprit largeur de l'objet pointeur
            ipointeurImageLire->hauteur = hauteur;//Fixe la valeur de la proprit hauteur de l'objet pointeur
            ipointeurImageLire->image = (UCHAR *)malloc(ipointeurImageLire->hauteur*ipointeurImageLire->largeur);//Rservation de l'espace mmoire pour stocker l'image retourne un  pointeur IMAGE
            nombreByteLus=fread(ipointeurImageLire->image,sizeof(UCHAR),ipointeurImageLire->hauteur*ipointeurImageLire->largeur,fpPointeurFichier);//lecture du fichier, retourne bytes lus
            printf("\nBytes lus =%i h=%i, l=%i",nombreByteLus,ipointeurImageLire->hauteur,ipointeurImageLire->largeur);
            if (nombreByteLus == grosseur ){// Si nombre de bytes lus est gal  ce qui devait tre lu
                probleme = 0; // pas de problmes
                printf("\nLecture du fichier est OK, on continue avec le traitement...");
            }
            else{
                printf("\nErreur de lecture %i n'est pas egal a grosseur %i",nombreByteLus,grosseur);// Lecture des bytes lus et attendus ne correspond pas
                probleme = 1;// Il ya eu un problme
            }
        }
        else{
            probleme = 1;// Il ya eu un problme
            printf("\nErreur dans l'entree des reponses ");
        }
    }
    fclose(fpPointeurFichier); // Libre le pointeur de fichier
    if (probleme == 1){
        ipointeurImageLire = NULL ; // pointeur d'image  null pour manifester problme
        return(ipointeurImageLire);// retourne le pointeur
    }else{ // Si pas de problmes
        return(ipointeurImageLire);// retourne le pointeur
    }
}
//Fonction: crit une image sur le disque
//Entree: Le pointeur de l'image  crire sur le disque
//Sortie: Rien
IMAGE *crypter_decrypter(IMAGE * ipointeurImage){

    struct _timeb start,finish; // Dclaration des variables pour le chronometrage
    unsigned long duration;  // Dclaration de la variable pour la dure
    unsigned char encodage; // Dclaration de la variable pour l'encodage
    int reponse, L, H, m, n; // Variables pour les calculs

    L= ipointeurImage->largeur; // Stocke la proprit de l'image dans des var
    H= ipointeurImage->hauteur;// Stocke la proprit de l'image dans des var
    printf(" \n Veuillez entrer l'encodage a effectuer de 0 a 255: ");
    scanf("%d", &encodage); //Capture l'encodage dsir
    printf(" \nEst-ce que vous desirez effectuer le calcul par 1)ligne ou 2)par colonne ou 3)veut pas l'savoir \n ");
    scanf("%i", &reponse);//Capture de la mthode dsire
    if (reponse==1){ // Par ligne
        _ftime(&start); // Stocke la valeur du temps de dpart
        for(m=0;m<H;m++){ // Acces avec positionnement spatial parcours par colonne
            for(n=0;n<L;n++){ // Parcours par rangee
               ipointeurImage->image[m*L+n] = ipointeurImage->image[m*L+n]^encodage; /*XOR*/
            }
        }
        _ftime(&finish);// Stocke la valeur du temps de terminaison
        duration = ((unsigned long)finish.time * 1000L + (unsigned long)finish.millitm) - ((unsigned long)start.time * 1000L + (unsigned long)start.millitm); // Calcul du temps dexecution en ms
        printf ("Temps d'execution avec positionnement spatial par rangee : %d ms\n", duration); //Affiche la dure du process
    }
    else if (reponse==2){// Par colonne
        _ftime(&start); // Stocke la valeur du temps de dpart
        for(n=0;n<L;n++){// Acces avec positionnement spatial
            for(m=0;m<H;m++){ // Parcours par colonne
                ipointeurImage->image[m*L+n] = ipointeurImage->image[m*L+n]^encodage; /*XOR*/
            }
        }
        _ftime(&finish);// Stocke la valeur du temps de terminaison
        duration = ((unsigned long)finish.time * 1000L + (unsigned long)finish.millitm) - ((unsigned long)start.time * 1000L + (unsigned long)start.millitm); // Calcul du temps dexecution en ms
        printf ("Temps d'execution avec positionnement spatial par colonne : %d ms\n", duration);//Affiche la dure du process
    }
    else if (reponse==3){// Sans positionnement spatial
        _ftime(&start);// Stocke la valeur du temps de dpart
        for(m=0;m<H*L;m++){ // Acces sans positionnement spatial de facon lineaire
            ipointeurImage->image[m] = ipointeurImage->image[m]^encodage; /*XOR*/
        }
        _ftime(&finish);// Stocke la valeur du temps de terminaison
        duration = ((unsigned long)finish.time * 1000L + (unsigned long)finish.millitm) - ((unsigned long)start.time * 1000L + (unsigned long)start.millitm);// Calcul du temps dexecution en ms
        printf ("Temps d'execution acces sans positionnement spatial : %d ms\n", duration);//Affiche la dure du process
    }
    else{
        printf ("Mauvaise entree de commande");
    }
    return ipointeurImage;
}
//Fonction: crit une image sur le disque
//Entree: Le pointeur de l'image  crire sur le disque
//Sortie: Rien
void ecrire_image(IMAGE * ipointeurImage){

    char nomfichier[254];  // variable pour chemin du fichier
    FILE *fpPointeurFichier; // pointeur pour fichier  crer
    int nombreBytesAEcrire = ipointeurImage->hauteur*ipointeurImage->largeur; // Fixe le nombre de bytes  crire
    int nombreBytesEcrit; // var pour nombre de bytes crit

    printf(" \nVeuillez entrer le nom du fichier a ecrire max 250 car: ");
    scanf("%s", &nomfichier); // Capture le nom de fichier (avec le chemin)
    fpPointeurFichier = fopen(nomfichier,"w+");// Ouvre le fichier en criture
    nombreBytesEcrit = fwrite(ipointeurImage->image,sizeof(UCHAR),ipointeurImage->hauteur*ipointeurImage->largeur,fpPointeurFichier); //criture de l'image
    if (nombreBytesAEcrire == nombreBytesEcrit){//voir si fwrite() retourne une valeur valide de nombre de bytes crits = nombre de bytes attendus
        printf ("L'ecriture est un succes \nFermeture du programme");
    }
    else{
        printf ("L'ecriture du fichier est un echec");
    }
    fclose(fpPointeurFichier);//Libration du pointeur de fichier
}
