//################################################################################################
Anteur : - DIALLO OUSMANE

Travail Pratique #3 Codage (Cryptage) d'image

//################################################################################################
#include <stdio.h>
#include <stdlib.h>

//DECLARATION DES VARIABLES ET STRUCTURES
typedef unsigned char  UCHAR;

struct IMAGERAW
{
    int hauteur;
    int largeur;
    UCHAR * image;
};

typedef struct IMAGERAW IMAGE;

IMAGE *lire_image();
IMAGE *crypter_decrypter(IMAGE*im);
void ecrire_image(IMAGE *imageD);

int main()
{
//DECLARATION D'UN POINTEUR SUR UNE STRUCTURE IMAGE
    IMAGE *im;

// LECTURE DE L’IMAGE A CRYPTER

    im = lire_image() ;

// CRYPTAGE DE L'IMAGE

    crypter_decrypter(im);

// SAUVEGARDE DE L’IMAGE CRYPTEE

    ecrire_image(im);

// LIBERER LA  RAM ATTRIBUEE DYNAMIQUEMENT

    free(im->image);
    free(im);

    printf("\n* L'image a ete crypte avec succes * \n");
    return 0;
}

// la fonction qui permet la lecture de l'image à cryptée ou
IMAGE *lire_image()
{
    IMAGE *im;
    FILE *fpI;
    //ouvrir le fichier en lecture
    fpI = fopen("benji.raw","rb");
    if (fpI == NULL)
    {
        printf("Erreur lors de l'ouverture du fichier\n");
    }
    //Reserver un espace memoire pour  im
    im = (IMAGE *)malloc(sizeof(IMAGE));
    im->largeur = 1690;
    im->hauteur = 1409;
    im->image = (UCHAR *) malloc(im->hauteur*im->largeur);
    //Lire l’image sur le disque
    fread(im->image,sizeof(UCHAR),im->hauteur*im->largeur,fpI);
    //fermer le fichier
    fclose(fpI);
    //RETOURNER LE POINTEUR SUR IMAGE
    return(im);

}

// La fonction qui permet le cryptage et le décryptage d'image  avec un fonction de codage XOR.
IMAGE *crypter_decrypter(IMAGE*im)
{
    int L,H,m,n;
    // Demander et valider la valeur de la clé entre 0 et 255
    printf("Entrez le cle de cryptage/decryptage (entre 0-255) : ");
    unsigned int cle;
    scanf("%u",&cle);
    while (cle < 0 || cle > 255)                              /// boucle permetant la validation du nombre de division
    {
        printf("Entrez le cle de cryptage/decryptage (entre 0-255) : ");
        scanf("%u", &cle);
    }
    //Demander l’ordre de parcours de la matrice (rangée ou colonne)
    printf("Tapez 1 si vous voulez faire un parcours par colonne et tapez 0 si par rangee : ");
    unsigned int parcours;
    scanf("%u",&parcours);

    // Acces avec positionnement spatial dans une image
    L = im->largeur; // largeur de l’image
    H = im->hauteur; // hauteur de l’image
    if(parcours)
    {
        for(m=0; m<H; m++) // Acces avec positionnement
            for(n=0; n<L; n++) // Parcours par rangee
                im->image[m*L+n] = im->image[m*L+n]^cle; /*XOR*/
    }
    else if(!parcours)
    {
        for(n=0; n<L; n++) // Acces avec positionnement spatial
            for(m=0; m<H; m++) // Parcours par colonne
                im->image[m*L+n] = im->image[m*L+n]^cle; /*XOR*/
    }
}

// La fonction qui permet la sauvegarde de l'image cryptée ou décryptée
void ecrire_image(IMAGE *imageD)
{

    FILE *fpD;
    // Ouverture de fichier
    fpD = fopen("Decript.raw","wb");
    //Ecriture de fichier
    fwrite(imageD->image,sizeof(UCHAR),imageD->hauteur*imageD->largeur,fpD); // voir si fwrite() retourne une valeur valide

    //Fermeture de fichier
    fclose(fpD);


}


