/* travail3.cpp : Ce fichier contient la fonction 'main'.L'exécution du programme commence et se termine à cet endroit.
Auteurs: Léanne Emond Maheux (EMOL74530409), Lily Occhibelli (OCCL72360500), Océane Rakotoarisoa (RAKO77350500)
Date: 07/12/23
Cours: SIF1053 Gr 01
*/

// Pour que Visual Studio compile le code avec "scanf"
#define _CRT_SECURE_NO_WARNINGS

// Fichiers .h requis pour les différentes fonction
#include <malloc.h>
#include <stdio.h>
#include <conio.h>
#include <sys/timeb.h>

// Définition de types utiles (UCHAR et IMAGE)
typedef unsigned char UCHAR;
typedef struct IMAGERAW {
    int hauteur;
    int largeur;
    UCHAR* image;
} IMAGE;


// Prototypes des fonctions
IMAGE* lireImageFFM();
IMAGE* lireImageRAW();
void crypterDecrypter(IMAGE* im);
void ecrireImage(IMAGE* imageD);


void main()
{
    /*
    main:
    - Point d'entrée du programme
    - Déclare un pointeur sur une struct IMAGE
    - Appelle les fonctions pour lire, crypter et écrire une image à partir du pointeur déclaré
    - Libère la mémoire utilisée par le programme
    ENTRÉE: aucune
    SORTIE: aucune
*/
    IMAGE* im; // déclaration d'un pointeur sur une structure image
    
    // im = lireImageFFM();
    im = lireImageRAW(); // lecture de l'image à crypter et affectation au pointeur im

    if (im != NULL) { // s'il n'y a pas d'erreur lors de la lecture du fichier
        crypterDecrypter(im); // cryptage de l'image
        ecrireImage(im); // enregistrer l'image cryptée

        // -- * LIBÉRATION DU RAM ATTRIBUÉ DYNAMIQUEMENT * --
        free(im->image); // libère UCHAR* image, l'image ayant été générée (cryptée)
        free(im); // libère la struct IMAGERAW, toutes ses variables
    }
}

IMAGE* lireImageFFM() {
    /*
    lireImageFFM:
    - Lit un fichier de type FFM dont le nom est entré par l'utilisateur et vérifié
    - Alloue un espace en mémoire selon la taille de l'image
    - Assigne toutes les valeurs nécessaires (hauteur, largeur, image) à un pointeur IMAGE
    - Retour de ce pointeur IMAGE s'il n'y a pas eu d'erreur de lecture
    ENTRÉE: aucune
    SORTIE: IMAGE* (pointeur à une struct IMAGE)
    */
    char nomFichier[80];
    FILE* fpI;
    IMAGE* im;

    //Entrée du nom de fichier + assignation à fpI
    printf("Entrez le nom du fichier (incluant l'extension). [Le fichier doit etre dans le repertoire de l'executable]\n");
    scanf("%s", &nomFichier);
    while (!(fpI = fopen(nomFichier, "rb"))) { // si fichier non trouvé ou erreur de lecture du fichier
        printf("Fichier non-trouve. Veuillez reessayer.\n");
        scanf("%s", &nomFichier);
    }

    im = (IMAGE*)malloc(sizeof(IMAGE)); // allocation de l'espace nécessaire, cast en pointeur IMAGE* pour malloc

    //Lecture de la hauteur et largeur de l’image (int h, l;) et l'inscrit dans la struct IMAGERAW de variable im
    fread(&im->hauteur, sizeof(int), 1, fpI); // # de lignes
    fread(&im->largeur, sizeof(int), 1, fpI); // # de colonnes 
    im->image = (UCHAR*) malloc(im->hauteur * im->largeur); // allocation de la mémoire requise pour faire les opérations sur l'image

   int nbOctets = fread(im->image, sizeof(UCHAR), im->hauteur * im->largeur, fpI); // lecture de l'image et assignation à la variable image de la struct IMAGE; int??
   fclose(fpI); // fermeture du fichier
   if (nbOctets != im->hauteur * im->largeur) { // vérification du nb d'Octets lus
       printf("Erreur lors de la lecture du fichier.\n");
       return NULL; 
   }
   else {
       return (im);
   }
}

IMAGE* lireImageRAW() {
    /*
    lireImageRAW:
    - Lit un fichier de type RAW dont le nom est entré par l'utilisateur et vérifié
    - Alloue un espace en mémoire selon la taille de l'image
    - Assigne toutes les valeurs nécessaires (hauteur, largeur, image) à un pointeur IMAGE
    - Retour de ce pointeur IMAGE s'il n'y a pas eu d'erreur de lecture
    ENTRÉE: aucune
    SORTIE: IMAGE* (pointeur à une struct IMAGE)
    */
    char nomFichier[80];
    FILE* fpI;
    IMAGE* im;
    int h, l;
    //Entrée du nom de fichier + assignation à fpI
    printf("Entrez le nom du fichier (incluant l'extension). [Le fichier doit etre dans le repertoire de l'executable]\n");
    scanf("%s", &nomFichier);
    while (!(fpI = fopen(nomFichier, "rb"))) { // vérification du nom du fichier + vérif de son existence
        printf("Fichier non-trouve. Veuillez reessayer.\n");
        scanf("%s", &nomFichier);
    }

    // Entrée de la largeur et hauteur de l'image par l'utilisateur
    printf("Veuillez entrer la largeur et la hauteur de l'image (lxh)(lignesxcolonnes)\n");
    scanf("%dx%d", &l, &h);
    while (l < 0 || l > 20000 || h < 1 || h> 20000) { // vérification que la largeur et hauteur soient dans [0,20000]
        scanf("%dx%d", &l, &h);
    }

    // Assignation des valeurs aux variables de la struct IMAGE de nom im
    im = (IMAGE*)malloc(sizeof(IMAGE)); // cast en pointeur IMAGE* pour malloc, allocation de l'espace nécessaire
    im->largeur = l;
    im->hauteur = h;
    im->image = (UCHAR*)malloc(im->hauteur * im->largeur);

    int nbOctets = fread(im->image, sizeof(UCHAR), im->hauteur * im->largeur, fpI); // lecture de l'image et assignation à la variable image de la struct IMAGE; int??
    fclose(fpI);
    if (nbOctets != im->hauteur * im->largeur) { // si erreur de lecture
        printf("Erreur lors de la lecture du fichier.\n");
        return NULL; 
    }
    else {
        return (im);
    }
}
void crypterDecrypter(IMAGE* im) {
    /*
  crypterDecrypter:
  - Crypte/décrypte l'image passé en argument
  - Entrée de la clé et de l'ordre de parcours de la matrice + vérification de l'entrée
  - Parcours de la matrice selon le choix de l'utilisateur + chronométrage du temps de parcours + impression du temps à la console
  ENTRÉE: IMAGE* (pointeur à une struct IMAGE)
  SORTIE: aucune
  */

    // Variables pour calculer le temps pour traverser la matrice image
    unsigned long duree;
    struct _timeb start, finish;

    int L, H, i, j, parcours;
    UCHAR cle;
    IMAGE* img =im; 

    L = img->largeur;
    H = img->hauteur;

    // Entrée de la valeur de la clé par l'utilisateur + vérification
    printf("Veuillez entrer la cle entre 0 et 255.\n");
    scanf("%hhu", &cle);
    while (cle < 0 || cle > 255) {
        printf("Veuillez entrer une cle entre 0 et 255 (inclusivement).\n");
        scanf("%hhu", &cle);
    }
    // Sélection de l'ordre de parcours de la matrice + vérification
    printf("L'image sera parcourue par rangee [0] ou colonne [1]?\n");
    scanf("%d", &parcours);
    while (parcours != 1 && parcours!= 0) {
        scanf("%d", &parcours);
    }

    // -- * Différentes méthodes de parcours de la matrice * --
    if (parcours == 0) { // parcours par rangée, + vite
        _ftime(&start); // début du chronomètre
        for (i = 0; i < H; i++)  // parcours à travers les rangées
            for (j = 0; j < L; j++)   // parcours à travers les colonnes
                img->image[i * L + j] = img->image[i * L + j] ^ cle; // opération XOR
        _ftime(&finish);// fin du chronomètre
    }
    else if (parcours == 1) { // parcours par colonne, - vite
        _ftime(&start); // début du chronomètre
        for (j = 0; j < L; j++) // parcours à travers les colonnes
            for (i = 0; i < H; i++) // Parcours par rangée
                img->image[i * L + j] = img->image[i * L + j] ^ cle; // opération XOR
        _ftime(&finish); // fin du chronomètre
    }
    
    duree = ((unsigned long)finish.time * 1000L + (unsigned long)finish.millitm) - ((unsigned long)start.time * 1000L + (unsigned long)start.millitm); // calcul de la durée de l'opération
    printf("Le temps d'execution est: %d milisecondes\n", duree);

}

void ecrireImage(IMAGE *imageD) {
    /*
  ecrireImage:
  - Entrée du nouveau nom de fichier en sortie par l'utilisateur
  - Écriture du fichier + fermeture du fichier
  ENTRÉE: IMAGE* (pointeur à une struct IMAGE)
  SORTIE: aucune
  */
    char nomFichier[80];
    FILE* fpD;
    // Entrée du nom du fichier
    printf("Entrez le nom du fichier à la sortie (incluant l'extension)\n");
    scanf("%s", &nomFichier);
    // Écriture du fichier
    fpD = fopen(nomFichier, "wb");
   int nbOctets = fwrite(imageD->image, sizeof(UCHAR), imageD->hauteur * imageD->largeur, fpD); // int??
   if (nbOctets != imageD->hauteur * imageD->largeur) { // si erreur d'écriture
       printf("Erreur lors de l'ecriture du fichier.");
   }
   fclose(fpD);
}