/*

 * JERIEL TCHUINKWA TANDU (TCHJ85330100)
 * SONFACK MALESSONG LOIC KEVIN (SONL72260000)
 * BAH AMINATOU  (BAHA68300400)
 * KAPCHE TAPE HOMERINE PHALONE (KAPH80370200)
 * YANN OTHNIEL DIBY

 */


// Bibliothèques standards du langage C ou C++ 
#include <stdio.h>
#include <stdlib.h>

typedef unsigned char UCHAR;

struct IMAGERAW {
    int hauteur;
    int largeur;
    UCHAR* image;
};

typedef struct IMAGERAW IMAGE;

IMAGE* lire_image();
IMAGE* crypter_decrypter(IMAGE* im);
void ecrire_image(IMAGE* imageD);

//Fonction principale main()
int main() {

    // Déclaration d'un pointeur sur une structure image  S
    IMAGE* im;
    // Lecture de l'image à crypter
    im = lire_image();

    if (im == NULL) {
        printf("Erreur lors de la lecture de l'image.\n");
        return 1;
    }
    // Cryptage de l'image 
    crypter_decrypter(im);

    // Sauvegarde de l'image cryptée
    ecrire_image(im);

    // Liberer la RAM attribuée dynamiquement
    free(im->image);
    free(im);
    printf("\nFélicitation : l'image benji.raw a été cryptée !\n");
    return 0;
}

// Fonction  permettant la lecture d'une image à crypter
IMAGE* lire_image() {
    // Ouverture / lecture / Fermeture de fichier
    IMAGE* im;
    FILE* fpI;
    // Permet d'ouvrir un fichier en lecture
    fpI = fopen("benji.raw", "rb");


    if (fpI == NULL) {
        printf("Le fichier n'a pas été ouvert.\n");
        return NULL;
    }

    //Reserver un espace memoire pour im
    im = (IMAGE*)malloc(sizeof(IMAGE));
    im->hauteur = 1409;
    im->largeur = 1690;
    im->image = (UCHAR*)malloc(im->hauteur * im->largeur);

    //Lire l’image sur le disque
    fread(im->image, sizeof(UCHAR), im->hauteur * im->largeur, fpI);

    // Permet de fermer un fichier 
    fclose(fpI);

    //Retourner le pointeur sur image 
    return im;
}

// Fonction permettant de crypter et de décrypter l'image  
IMAGE* crypter_decrypter(IMAGE* im) {
    int L, H, m, n;
    printf("Veuillez entrer la clé de cryptage ou de décryptage entre 0 - 255 : ");
    unsigned int cle;
    scanf("%u", &cle);

    while (cle < 0 || cle > 255) {
        printf("Veuillez entrer la clé de cryptage ou de décryptage entre 0-255 : ");
        scanf("%u", &cle);
    }

    printf("Tapez 1 pour parcourir par colonne et tapez 0 pour parcourir par rangée : ");
    unsigned int parcours;
    scanf("%u", &parcours);

    /* Acces avec positionnement spatial dans une image */

    // La largeur de l’image
    L = im->largeur;
    // La hauteur de l’image
    H = im->hauteur;

    if (parcours) {

        // Acces avec positionnement
        for (m = 0; m < H; m++)
            // Parcours par rangée
            for (n = 0; n < L; n++)
                /*XOR*/
                im->image[m * L + n] = im->image[m * L + n] ^ cle;
    }
    else {
        // Acces avec positionnement spatial
        for (n = 0; n < L; n++)
            // Parcours par colonne
            for (m = 0; m < H; m++)
                /*XOR*/
                im->image[m * L + n] = im->image[m * L + n] ^ cle;
    }

    return im;
}

// Fonction permettant de sauvegarder une image 
void ecrire_image(IMAGE* imageD) {
    /* OUVERTURE, ECRITURE ET  FERMETURE DE FICHIER */
    FILE* fpD;
    // Demander nom de fichier a ecrire
    fpD = fopen("Decript.raw", "wb");
    // permet d'écrire sur un fichier
    if (fpD == NULL) {
        printf("Le fichier de sortie n'a pas pu être ouvert.\n");
        return;
    }

    fwrite(imageD->image, sizeof(UCHAR), imageD->hauteur * imageD->largeur, fpD);
    
    //Permet de fermer un fichier
    fclose(fpD);
}