#ifndef TP3_H
#define TP3_H

typedef unsigned char UCHAR;

struct IMAGERAW {
    int hauteur;
    int largeur;
    UCHAR *image;
};

typedef struct IMAGERAW IMAGE;

/**
 * @brief Fonction pour lire une image à partir d'un fichier.
 * 
 * @return Un pointeur vers une structure IMAGE contenant les données de l'image.
 */
IMAGE *lire_image();

/**
 * @brief Fonction pour crypter ou décrypter une image en utilisant une clé et un mode de parcours spécifié.
 * 
 * @param im Pointeur vers la structure IMAGE représentant l'image à crypter ou décrypter.
 * @return Un pointeur vers la structure IMAGE après l'opération de cryptage ou décryptage.
 */
IMAGE *crypter_decrypter(IMAGE *im);

/**
 * @brief Fonction pour écrire une image dans un fichier.
 * 
 * @param imageD Pointeur vers la structure IMAGE représentant l'image à écrire.
 */
void ecrire_image(IMAGE *imageD);

#endif  
