/************************************************************************************************************************/
/** Tp3 SIF 1053 membre du groupe:DIABATE Izdine Ibn Oumar (DIAI64300400) groupe01      **/
/***************************************************************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <sys/timeb.h>
#include <time.h>
#include <string.h>

 //UCHAR permet de stocker des valeur entre [0, 255]
typedef unsigned char UCHAR;

//type BOOL
typedef unsigned char BOOL;

//structure IMAGERAW facilitant la representaion d'une d'image

struct IMAGERAW {
    int hauteur;
    int largeur;
    UCHAR* image; //tableau pour stocker les pixels de l'image
};
typedef struct IMAGERAW IMAGE;

//fonction pour la lecture de l'image

IMAGE* lire_image();
void crypter_decrypter(IMAGE **imageS, UCHAR cle);
void ecrire_image(IMAGE *imageD, char nomFichier[]);

int main()
{
    UCHAR cle;
    char nomFichier[80]; //Dans main(), nomFichier est utilis pour l'criture du fichier final

    //Lecture de l'image
    IMAGE* image = lire_image();

    printf("Entrez la cle de cryptage/decryptage : ");
    scanf("%hhu", &cle); // La cl est scann sous le format unsigned char, donc si la valeur excde 255 elle retombe  0
    while ((getchar()) != '\n'); //Clearing du buffer de scanf pour enlever le saut de ligne
    crypter_decrypter(&image, cle); //Cryptage/Dcryptage utilise la mme fonction


    printf("\nEntrez le nom du fichier a sauvegarder sans l'extension : ");
    scanf("%s", nomFichier);
    while ((getchar()) != '\n');
    ecrire_image(image, nomFichier); //criture de l'image

    printf("\n\nOperation complete, fermeture du programme...");

    return 0;
}

//Fonction "lire_image"
//Permet la lecture de l'image  crypter ou  decrypte de type .raw ou .ffm
//              et d'en stocker l'information dans la variable image
//              d'une structure IMAGERAW

IMAGE* lire_image() {
    IMAGE* image = (IMAGE*)malloc(sizeof(IMAGE));
    char nomFichier[80]; //Nom du fichier  ouvrir dans cette fonction
    char extension[20]; //Extension (soit .raw ou .ffm)
    BOOL extensionRaw = 0;
    BOOL extensionFfm = 0;
    BOOL loop = 1;

    FILE *fichier;
    //
    //Rcupration du nom de fichier et de l'extension

    do {
        printf("Entrez le nom du fichier avec un espace (en place du point) avant l'extension (ex : nomFichier raw OU nomFichier ffm) \n");
        scanf("%s %s", &nomFichier, &extension);
        //On teste pour savoir si l'extension scanne est valide
        extensionRaw = (strcmp("raw", extension) == 0);
        extensionFfm = (strcmp("ffm", extension) == 0);

        if(!extensionRaw && !extensionFfm)
            printf("Format invalide\n");
        else
            loop = 0;
    } while(loop);

    //Ouverture du fichier

    strcat(nomFichier, ".");        //On concate le nom du fichier, un point et l'extension ensemble
    strcat(nomFichier, extension);
    if ((fichier = fopen(nomFichier, "rb")) == NULL) { //Teste l'ouverture
            printf("Erreur dans l'ouverture du fichier, fermeture du programme..");
            exit(0);
    }

    //Recuperation des dimensions dpendament du format du fichier
    //
    if(extensionRaw) {
        printf("Entrez la largeur puis la hauteur suivant le format suivant : (largeur) x (hauteur) \n");
        scanf("%d x %d", &image->largeur, &image->hauteur);
    }
    else { //Si le fichier est un .ffm
        fread(&image->hauteur, sizeof(int), 1, fichier); //Lecture des dimensions qui sont les 4 premiers bytes du fichier ffm
        fread(&image->largeur, sizeof(int), 1, fichier); //C'est--dire 2 bytes pour la hauteur et 2 bytes pour la largeur
        printf("Les dimensions du fichier .ffm sont : LARGEUR -> %d x HAUTEUR -> %d\n", image->largeur, image->hauteur);
    }

    //Allocation de la mmoire pour le stockage de l'image

    if((image->image = (UCHAR*)malloc(image->largeur * image->hauteur)) == NULL) {
        printf("Erreur d'allocation de memoire pour IMAGE *image, fermeture du programme...");
        exit(0);
    }

    //Lecture du fichier
    fread(image->image, sizeof(UCHAR), image->hauteur*image->largeur, fichier);


    printf("Image ouverte avec succes.\n\n");
    fclose(fichier);
    return image;
}

//Fonction "crypter_decrypter"
//Elle  Permet de crypter/dcrypter d'image avec une fonction de codage XOR     .

void crypter_decrypter(IMAGE **imageS, UCHAR cle)  {
    int i, j;
    char choix;

    //temps d'excution

    struct _timeb start, finish;
    unsigned long duration;

    do {
        printf("Faire le cryptage par colonne ou ligne? (Entrez 'c' pour colonne, 'l' pour ligne) :");
        scanf("%c", &choix);
        if(choix == 'c') {  //Cryptage simple XOR o une operation XOR est appliqu sur chaque pixel avec la cl puis le rsulta rassign au pixel correspondant
            _ftime(&start);
            for (i = 0; i < (*imageS)->largeur; i++) {
                for (j = 0; j < (*imageS)->hauteur; j++) { //Les colonnes sont traverss en premier, puis les lignes
                    (*imageS)->image[ (j * (*imageS)->largeur) + i] ^= cle;
                }
            }
            _ftime(&finish);
        }
        else if (choix == 'l') {
            _ftime(&start);
            for (i = 0; i < ((*imageS)->hauteur * (*imageS)->largeur); i++) {
                (*imageS)->image[i] ^= cle; //Cryptage par ligne qui se fait en traversant chaque lment un par un puisque ils sont adjacents
            }
            _ftime(&finish);

        }
        else {
            printf("Choix invalide\n");
            while ((getchar()) != '\n');
        }

    } while(choix != 'l' && choix != 'c');
    duration = ((unsigned long)finish.time * 1000L + (unsigned long)finish.millitm) - ((unsigned long)start.time * 1000L + (unsigned long)start.millitm);//Calcul du temps


    printf("Cryptage en mode '%c' effectue avec succes en %d ms\n", choix, duration);

    //Pas de return dans cette fonction
}

//Fonction "Ecrire_image"
//Elle Permet la sauvegarde de l'image crypte ou dcrypte.

void ecrire_image(IMAGE *imageD, char nomFichier[]) {
    FILE *fichierW;
    BOOL rawFormat = NULL;
    char choix;

    //Choix de l'extension du fichier  sauvegarder

    do {
        printf("Choisir l'extension de l'image ('r' pour raw ou 'f' pour ffm) : ");
        scanf("%c", &choix);
    } while(choix != 'r' && choix != 'f');
    rawFormat = (choix == 'r') ? 1:0;

    //Ouverture du fichier

    strcat(nomFichier, rawFormat ? ".raw":".ffm"); //S'il s'agit d'un fichier raw on le sauvegarde en .raw et de mme pour un fichier ffm
    if((fichierW = fopen(nomFichier, "wb")) == NULL) {
        printf("Erreur dans l'ouverture/creation du fichier pour criture, fermeture du programe...\n");
        exit(0);
    }

    //criture des dimensions si le fichier est un .ffm et ecriture du fichier

    if(!rawFormat) {
        fwrite(&imageD->hauteur, sizeof(int), 1, fichierW);
        fwrite(&imageD->largeur, sizeof(int), 1, fichierW);
    }
    fwrite(imageD->image, sizeof(UCHAR), imageD->hauteur * imageD->largeur, fichierW); //criture de l'image au complet avec fwrite
    fclose(fichierW);
}



